#include "Queue.h"


/*
function:
	Initialization queue.

parameter:
	pQ -- Pointer to a queue
*/
void InitQueue(Queue* pQ)
{
	pQ->begin = pQ->end = 0;
	pQ->length = 0;
}

/*
function:
	Insert the element at the end of the queue.

parameter:
	pQ -- Pointer to a queue
	Elem -- Elements of enrolling
  
returned value:
	Returns the value of the enqueued element if the insert is successful.
	Returns -1 if insert fails.
*/
int EnQueue(Queue* pQ, int Elem)
{
	//
	// Queue full, fail to join.
	//
	if (MAX_QUEUE_LENGTH == pQ->length)
	{
		return -1;
	}
		
	pQ->buffer[pQ->end] = Elem;
	pQ->end = (pQ->end + 1) % MAX_QUEUE_LENGTH;
	pQ->length++;
	
	return Elem;
}

/*
function:
	Remove the first element from the team

parameter:
	pQ -- Pointer to a queue
  
returned value:
	Returns the value of the queued element if queued successfully.
	Returns -1 if dequeuing fails.
*/
int DeQueue(Queue* pQ)
{
	int Elem;

	//
	// Queue empty, dequeue failed
	//	
	if (QueueEmpty(pQ))
	{
		return -1;
	}
	
	Elem = pQ->buffer[pQ->begin];
	pQ->begin = (pQ->begin + 1) % MAX_QUEUE_LENGTH;
	pQ->length--;
	
	return Elem;
}

/*
function:
	Determines if the queue is empty.

parameter:
	pQ -- Pointer to a queue
  
returned value:
	Returns 1 if the queue is empty.
	Returns 0 if the queue is non-empty.
*/
int QueueEmpty(Queue* pQ)
{
	return 0 == pQ->length ? 1 : 0;
}
